<?php

require_once("phpdom.inc.php");

//HTMLWikitH[}bgɕϊB
class PluginWysiwyg_BackConverter
{
    
    function PluginWysiwyg_BackConverter(){
        $this->dom= new DOM();
    }
    
    function convert($html){
        
        $html= $this->preprocess($html);
        $this->dom->parse($html);
        
        $this->list_stack= array();
        $this->rowspans= array();
        $this->quote_level= 0;
        $this->in_pre= false;
        $wiki= $this->convert_node($this->dom->get_root());
        
        return $this->postprocess($wiki);
        
    }
    
    function preprocess($html){
        $html= '<body>'.$html.'</body>';
            //[g1ȂDOMp[U{B
        $html= preg_replace_callback('/<\s*pre\s*>(.|\n)*?<\s*\/\s*pre\s*>/mi',
                array(&$this, "preprocess_pre"), $html);
            //DOM͂ɂ<pre>̉sĂ܂̂ŁA<br/>ɕϊĂB
        return $html;
    }
    
    function preprocess_pre($ary){
        return preg_replace('/\r\n|[\r\n]/', "<br/>", $ary[0]);
    }
    
    function postprocess($wiki){
        //ʂȋsĂꂢɂB
        return preg_replace("/\n{3,}/", "\n\n", $wiki);
    }
    
    function convert_node($node){
        if ($this->dom->is_text($node)){
            return $this->unescape($this->dom->get_text($node));
        }else{
            $tag_name= $this->dom->get_node_name($node);
            switch ($tag_name){
                
                case "body":
                    $result= "";
                    $children= $this->dom->get_childs($node);
                    for ($i= 0; $i < count($children); ++$i){
                        if ($this->is_br($children[$i])){
                            if ($this->is_br($children[$i+1])){
                                $result.= "\n\n";
                                ++$i;
                            }else if ($this->is_text_level($children[$i-1])
                                    && $this->is_text_level($children[$i+1])){
                                $result= chop($result)."~\n";
                            }
                        }else{
                            $result.= $this->convert_node($children[$i]);
                        }
                    }
                    return $result;
                    
                case "h2":
                    return "\n\n* ".$this->join_chomp($node)."\n\n";
                
                case "h3":
                    return "\n\n** ".$this->join_chomp($node)."\n\n";
                
                case "h4":
                    return "\n\n*** ".$this->join_chomp($node)."\n\n";
                
                case "div":
                    return "\n\n".$this->join_chomp($node)."\n\n";
                
                case "p":
                    return "\n\n".preg_replace('/&br;/', "~\n", $this->join_chomp($node))."\n\n";
                
                case "hr":
                    return "\n\n----\n\n";
                
                case "ul": case "ol": case "dl":
                    static $list_chars= array("ul" => "-", "ol" => "+", "dl" => ":");
                    $this->list_stack[]= $list_chars[$tag_name];
                    $result= $this->join_one_paragraph($node);
                    array_pop($this->list_stack);
                    if ($this->list_level() == 0){
                        $result= "\n\n".$result."\n\n";
                    }else{
                        $result= "\n".$result;
                    }
                    return $result;
                
                case "li": case "dt":
                    $list_char= $this->list_stack[$this->list_level()-1];
                    return str_repeat($list_char, $this->list_level())." ".
                        $this->join_chomp($node).
                        ($tag_name=="li" ? "\n" : " | ");
                
                case "dd":
                    return $this->join_chomp($node)."\n";
                    
                case "blockquote":
                    ++$this->quote_level;
                    $result= str_repeat(">", $this->quote_level)." ";
                    $result.= chop($this->join_one_paragraph($node))."\n";
                    if ($this->list_level() > 0 || $this->quote_level > 1)
                        $result.= str_repeat("<", $this->quote_level);
                    --$this->quote_level;
                    return "\n\n".$result."\n\n";
                    
                case "table":
                    $this->rowspans= array();
                    return "\n\n".$this->join($node)."\n\n";
                    
                case "tbody":
                    return $this->join_chomp($node);
                    
                case "tr":
                    $children= $this->dom->get_childs($node);
                    $result= "";
                    $this->col= $i= 0;
                    while ($i < count($children) || $this->col < count($this->rowspans)){
                        if ($this->rowspans[$this->col]){
                            $result.= "|~";
                            --$this->rowspans[$this->col];
                            ++$this->col;
                        }else{
                            $result.= $this->convert_node($children[$i]);
                            ++$i;
                        }
                    }
                    return $result."|\n";
                    
                case "td":
                    $result= "";
                    $colspan= (int)$this->dom->get_attrib($node, "colspan");
                    if (!$colspan) $colspan= 1;
                    $rowspan= (int)$this->dom->get_attrib($node, "rowspan");
                    if (!$rowspan) $rowspan= 1;
                    for ($i= 0; $i < $colspan; ++$i){
                        $result.= "|" . ($i == $colspan-1 ? $this->join_chomp($node) : ">");
                        $this->rowspans[$this->col]= $rowspan-1;
                        ++$this->col;
                    }
                    return $result;
                    
                case "span": case "em": case "strong": case "strike":
                    $style= $this->dom->get_attrib($node, "style");
                    if ($tag_name=="strong" || ereg("font-weight: *bold", $style)){
                        $quote= "''";
                    }else if ($tag_name=="em" || ereg("font-style: *italic", $style)){
                        $quote= "'''";
                    }else if ($tag_name=="strike" || ereg("text-decoration: *line-through", $style)){
                        $quote= "%%";
                    }else{
                        $quote= "";
                    }
                    $result= preg_replace("/'''?|%%/", "", $this->join($node));
                    if (strlen($result)) $result= $quote.$result.$quote;
                    return $result;
                    
                case "font":
                    //Ƃ肠
                    return $this->join($node);
                    
                case "a":
                    return "[[".$this->dom->get_value($node).":".
                        $this->absolute_url($this->dom->get_attrib($node, "href"))."]]";
                    
                case "br":
                    return $this->in_pre ? "\n " : "&br;";
                    
                case "pre":
                    $this->in_pre= true;
                    $result= "\n\n ".$this->join($node)."\n\n";
                    $this->in_pre= false;
                    return $result;
                    
                default:
                    return $this->join($node);
                    //die("unsupported tag: ".$tag_name);
                    
            }
        }
    }
    
    function join($node, $glue= ""){
        $result= array();
        foreach ($this->dom->get_childs($node) as $child){
            $result[]= $this->convert_node($child);
        }
        return join($glue, $result);
    }
    
    function join_chomp($node, $glue= ""){
        return preg_replace('/&br;\z/', "", $this->join($node, $glue));
    }
    
    function join_one_paragraph($node, $glue= ""){
        return preg_replace('/\n{2,}/', "\n", $this->join($node, $glue));
    }
    
    function list_level(){
        return count($this->list_stack);
    }
    
    function is_br($node){
        return isset($node) && $this->dom->get_node_name($node)=="br";
    }
    
    function is_text($node){
        return isset($node) && $this->dom->is_text($node);
    }
    
    function is_text_level($node){
        static $tag_names= array("span", "strong", "em", "font", "a", "br");
        if ($this->is_text($node)) return true;
        $tag_name= $this->dom->get_node_name($node);
        return is_int(array_search($tag_name, $tag_names));
    }
    
    function absolute_url($url){
        global $script;
        if (preg_match('/:\/\//', $url)){
            return $url;
        }else if (preg_match('/^\//', $url)){
            return preg_replace('/(:\/\/.*?)\/.*$/', '$1'.$url, $script);
        }else{
            return preg_replace('/\/[^\/]*$/', '/'.$url, $script);
        }
    }
    
    function unescape($str){
        return preg_replace(array('/&lt;/', '/&gt;/', '/&quot;/', '/&amp;/'),
            array('<', '>', '"', '&'), $str);
    }
    
}
