<?php
// PukiWiki - Yet another WikiWikiWeb clone
// $Id: plugin_wysiwyg_convert_html.php,v 1.7 2005/01/21 13:17:16 henoheno Exp $
//
// function 'plugin_wysiwyg_convert_html()', wiki text parser
// and related classes-and-functions

require_once("make_link.inc.php");

function plugin_wysiwyg_convert_html($lines)
{
    global $vars, $digest;
    static $contents_id = 0;

    // Set digest
    $digest = md5(join('', get_source($vars['page'])));

    //print("<pre>");
    //print(join("\n", $lines));
    //print("</pre>");

    if (! is_array($lines)) $lines = explode("\n", $lines);

    $body = & new PluginWysiwyg_Body(++$contents_id);
    $body->parse($lines);
    
    return $body->toString();
}

// ubNvf
class PluginWysiwyg_Element
{
    var $parent;   // evf
    var $last;     // ɗvf}
    var $elements; // vf̔z

    function PluginWysiwyg_Element()
    {
        $this->elements = array();
        $this->last     = & $this;
    }

    function setParent(& $parent)
    {
        $this->parent = & $parent;
    }

    function & add(& $obj)
    {
        if ($this->canContain($obj)) {
            return $this->insert($obj);
        } else {
            return $this->parent->add($obj);
        }
    }

    function & insert(& $obj)
    {
        $obj->setParent($this);
        $this->elements[] = & $obj;

        return $this->last = & $obj->last;
    }

    function canContain($obj)
    {
        return TRUE;
    }

    function wrap($string, $tag, $param = '', $canomit = TRUE)
    {
        return ($canomit && $string == '') ? '' :
            '<' . $tag . $param . '>' . $string . '</' . $tag . '>';
    }

    function toString()
    {
        $ret = array();
        foreach (array_keys($this->elements) as $key)
            $ret[] = $this->elements[$key]->toString();
        return join("\n", $ret);
    }

    function dump($indent = 0)
    {
        $ret = str_repeat(' ', $indent) . get_class($this) . "\n";
        $indent += 2;
        foreach (array_keys($this->elements) as $key) {
            $ret .= is_object($this->elements[$key]) ?
                $this->elements[$key]->dump($indent) : '';
                //str_repeat(' ', $indent) . $this->elements[$key];
        }
        return $ret;
    }
}

function & PluginWysiwyg_Factory_Inline($text)
{
    if (substr($text, 0, 1) == '~') {
        // s '~' BpOtJn
        //wysiwyg: ҏW'~'c悤ɁAȂ
        return new PluginWysiwyg_Paragraph(' ' . $text);
        //return new PluginWysiwyg_Paragraph(' ' . substr($text, 1));
    } else {
        return new PluginWysiwyg_Inline($text);
    }
}

function & PluginWysiwyg_Factory_DList(& $root, $text)
{
    $out = explode('|', ltrim($text), 2);
    if (count($out) < 2) {
        return PluginWysiwyg_Factory_Inline($text);
    } else {
        return new PluginWysiwyg_DList($out);
    }
}

// '|'-separated table
function & PluginWysiwyg_Factory_Table(& $root, $text)
{
    if (! preg_match('/^\|(.+)\|([hHfFcC]?)$/', $text, $out)) {
        return PluginWysiwyg_Factory_Inline($text);
    } else {
        return new PluginWysiwyg_Table($out);
    }
}

// Comma-separated table
function & PluginWysiwyg_Factory_YTable(& $root, $text)
{
    if ($text == ',') {
        return PluginWysiwyg_Factory_Inline($text);
    } else {
        return new PluginWysiwyg_YTable(csv_explode(',', substr($text, 1)));
    }
}

function & PluginWysiwyg_Factory_Div(& $root, $text)
{
    //wysiwyg: #``̃vOC͓WJȂ
    //if (! preg_match('/^\#([^\(]+)(?:\((.*)\))?/', $text, $out) ||
    //    ! exist_plugin_convert($out[1])) {
        return new PluginWysiwyg_Paragraph($text);
    //} else {
    //    return new PluginWysiwyg_Div($out);
    //}
}

// CCvf
class PluginWysiwyg_Inline extends PluginWysiwyg_Element
{
    function PluginWysiwyg_Inline($text)
    {
        parent::PluginWysiwyg_Element();
        
        //wysiwyg: Ǒmake_linkg
        $this->elements[] = trim((substr($text, 0, 1) == "\n") ?
            $text : plugin_wysiwyg_make_link($text));
    }

    function & insert(& $obj)
    {
        $this->elements[] = $obj->elements[0];
        return $this;
    }

    function canContain($obj)
    {
        return is_a($obj, 'PluginWysiwyg_Inline');
    }

    function toString()
    {
        global $line_break;
        return join(($line_break ? '<br />' . "\n" : "\n"), $this->elements);
    }

    function & toPara($class = '')
    {
        $obj = & new PluginWysiwyg_Paragraph('', $class);
        $obj->insert($this);
        return $obj;
    }
}

// PluginWysiwyg_Paragraph: blank-line-separated sentences
class PluginWysiwyg_Paragraph extends PluginWysiwyg_Element
{
    var $param;

    function PluginWysiwyg_Paragraph($text, $param = '')
    {
        parent::PluginWysiwyg_Element();
        $this->param = $param;
        if ($text == '') return;

        //wysiwyg: ҏW'~'c悤ɁAȂ
        if (substr($text, 0, 1) == '~')
            $text = ' ' . $text;
            //$text = ' ' . substr($text, 1);

        $this->insert(PluginWysiwyg_Factory_Inline($text));
    }

    function canContain($obj)
    {
        return is_a($obj, 'PluginWysiwyg_Inline');
    }

    function toString()
    {
        if (ereg("MSIE", UA_NAME)){
            return $this->wrap(parent::toString(), 'p', $this->param);
        }else{
            //wysiwyg: MozilladesignMode<p>ƋρB
            return parent::toString()."<br/><br/>";
        }
    }
}

// * Heading1
// ** Heading2
// *** Heading3
class PluginWysiwyg_Heading extends PluginWysiwyg_Element
{
    var $level;
    var $id;
    var $msg_top;

    function PluginWysiwyg_Heading(& $root, $text)
    {
        parent::PluginWysiwyg_Element();

        $this->level = min(3, strspn($text, '*'));
        
        //wysiwyg: AJAID̕t͍sȂ
        $text = preg_replace('/^\*{0,3}/', '', $text);
        //list($text, $this->msg_top, $this->id) = $root->getAnchor($text, $this->level);
        
        $this->insert(PluginWysiwyg_Factory_Inline($text));
        $this->level++; // h2,h3,h4
    }

    function & insert(& $obj)
    {
        parent::insert($obj);
        return $this->last = & $this;
    }

    function canContain(& $obj)
    {
        return FALSE;
    }

    function toString()
    {
        return $this->msg_top .  $this->wrap(parent::toString(),
            'h' . $this->level, ' id="' . $this->id . '"');
    }
}

// ----
// Horizontal Rule
class PluginWysiwyg_HRule extends PluginWysiwyg_Element
{
    function PluginWysiwyg_HRule(& $root, $text)
    {
        parent::PluginWysiwyg_Element();
    }

    function canContain(& $obj)
    {
        return FALSE;
    }

    function toString()
    {
        global $hr;
        return $hr;
    }
}

class PluginWysiwyg_ListContainer extends PluginWysiwyg_Element
{
    var $tag;
    var $tag2;
    var $level;
    var $style;
    var $margin;
    var $left_margin;

    function PluginWysiwyg_ListContainer($tag, $tag2, $head, $text)
    {
        parent::PluginWysiwyg_Element();

        //}[W擾
        $var_margin      = '_' . $tag . '_margin';
        $var_left_margin = '_' . $tag . '_left_margin';

        global $$var_margin, $$var_left_margin;

        $this->margin      = $$var_margin;
        $this->left_margin = $$var_left_margin;

        //
        $this->tag   = $tag;
        $this->tag2  = $tag2;
        $this->level = min(3, strspn($text, $head));
        $text = ltrim(substr($text, $this->level));

        parent::insert(new PluginWysiwyg_ListElement($this->level, $tag2));
        if ($text != '')
            $this->last = & $this->last->insert(PluginWysiwyg_Factory_Inline($text));
    }

    function canContain(& $obj)
    {
        return (! is_a($obj, 'PluginWysiwyg_ListContainer')
            || ($this->tag == $obj->tag && $this->level == $obj->level));
    }

    function setParent(& $parent)
    {
        global $_list_pad_str;

        parent::setParent($parent);

        $step = $this->level;
        if (isset($parent->parent) && is_a($parent->parent, 'PluginWysiwyg_ListContainer'))
            $step -= $parent->parent->level;

        $margin = $this->margin * $step;
        if ($step == $this->level)
            $margin += $this->left_margin;

        $this->style = sprintf($_list_pad_str, $this->level, $margin, $margin);
    }

    function & insert(& $obj)
    {
        if (! is_a($obj, get_class($this)))
            return $this->last = & $this->last->insert($obj);

        // ŝ݂̎w莞UL/OLubNEo
        // BugTrack/524
        if (count($obj->elements) == 1 && empty($obj->elements[0]->elements))
            return $this->last->parent; // up to PluginWysiwyg_ListElement.

        // Move elements.
        foreach(array_keys($obj->elements) as $key)
            parent::insert($obj->elements[$key]);

        return $this->last;
    }

    function toString()
    {
        return $this->wrap(parent::toString(), $this->tag, $this->style);
    }
}

class PluginWysiwyg_ListElement extends PluginWysiwyg_Element
{
    function PluginWysiwyg_ListElement($level, $head)
    {
        parent::PluginWysiwyg_Element();
        $this->level = $level;
        $this->head  = $head;
    }

    function canContain(& $obj)
    {
        return (! is_a($obj, 'PluginWysiwyg_ListContainer') || ($obj->level > $this->level));
    }

    function toString()
    {
        return $this->wrap(parent::toString(), $this->head);
    }
}

// - One
// - Two
// - Three
class PluginWysiwyg_UList extends PluginWysiwyg_ListContainer
{
    function PluginWysiwyg_UList(& $root, $text)
    {
        parent::PluginWysiwyg_ListContainer('ul', 'li', '-', $text);
    }
}

// + One
// + Two
// + Three
class PluginWysiwyg_OList extends PluginWysiwyg_ListContainer
{
    function PluginWysiwyg_OList(& $root, $text)
    {
        parent::PluginWysiwyg_ListContainer('ol', 'li', '+', $text);
    }
}

// : definition1 | description1
// : definition2 | description2
// : definition3 | description3
class PluginWysiwyg_DList extends PluginWysiwyg_ListContainer
{
    function PluginWysiwyg_DList($out)
    {
        parent::PluginWysiwyg_ListContainer('dl', 'dt', ':', $out[0]);
        $this->last = & PluginWysiwyg_Element::insert(new PluginWysiwyg_ListElement($this->level, 'dd'));
        if ($out[1] != '')
            $this->last = & $this->last->insert(PluginWysiwyg_Factory_Inline($out[1]));
    }
}

// > Someting cited
// > like E-mail text
class PluginWysiwyg_BQuote extends PluginWysiwyg_Element
{
    var $level;

    function PluginWysiwyg_BQuote(& $root, $text)
    {
        parent::PluginWysiwyg_Element();

        $head = substr($text, 0, 1);
        $this->level = min(3, strspn($text, $head));
        $text = ltrim(substr($text, $this->level));

        if ($head == '<') { // Blockquote close
            $level       = $this->level;
            $this->level = 0;
            $this->last  = & $this->end($root, $level);
            if ($text != '')
                $this->last = & $this->last->insert(PluginWysiwyg_Factory_Inline($text));
        } else {
            $this->insert(PluginWysiwyg_Factory_Inline($text));
        }
    }

    function canContain(& $obj)
    {
        return (! is_a($obj, get_class($this)) || $obj->level >= $this->level);
    }

    function & insert(& $obj)
    {
        // BugTrack/521, BugTrack/545
        if (is_a($obj, 'inline'))
            return parent::insert($obj->toPara(' class="quotation"'));

        if (is_a($obj, 'PluginWysiwyg_BQuote') && $obj->level == $this->level && count($obj->elements)) {
            $obj = & $obj->elements[0];
            if (is_a($this->last, 'PluginWysiwyg_Paragraph') && count($obj->elements))
                $obj = & $obj->elements[0];
        }
        return parent::insert($obj);
    }

    function toString()
    {
        return $this->wrap(parent::toString(), 'blockquote');
    }

    function & end(& $root, $level)
    {
        $parent = & $root->last;

        while (is_object($parent)) {
            if (is_a($parent, 'PluginWysiwyg_BQuote') && $parent->level == $level)
                return $parent->parent;
            $parent = & $parent->parent;
        }
        return $this;
    }
}

class PluginWysiwyg_TableCell extends PluginWysiwyg_Element
{
    var $tag = 'td'; // {td|th}
    var $colspan = 1;
    var $rowspan = 1;
    var $style; // is array('width'=>, 'align'=>...);

    function PluginWysiwyg_TableCell($text, $is_template = FALSE)
    {
        parent::PluginWysiwyg_Element();
        $this->style = $matches = array();

        while (preg_match('/^(?:(LEFT|CENTER|RIGHT)|(BG)?COLOR\(([#\w]+)\)|SIZE\((\d+)\)):(.*)$/',
            $text, $matches)) {
            if ($matches[1]) {
                $this->style['align'] = 'text-align:' . strtolower($matches[1]) . ';';
                $text = $matches[5];
            } else if ($matches[3]) {
                $name = $matches[2] ? 'background-color' : 'color';
                $this->style[$name] = $name . ':' . htmlspecialchars($matches[3]) . ';';
                $text = $matches[5];
            } else if ($matches[4]) {
                $this->style['size'] = 'font-size:' . htmlspecialchars($matches[4]) . 'px;';
                $text = $matches[5];
            }
        }
        if ($is_template && is_numeric($text))
            $this->style['width'] = 'width:' . $text . 'px;';

        if ($text == '>') {
            $this->colspan = 0;
        } else if ($text == '~') {
            $this->rowspan = 0;
        } else if (substr($text, 0, 1) == '~') {
            $this->tag = 'th';
            $text      = substr($text, 1);
        }

        if ($text != '' && $text{0} == '#') {
            // Ze'#'Ŏn܂ƂDivNXʂĂ݂
            $obj = & PluginWysiwyg_Factory_Div($this, $text);
            if (is_a($obj, 'PluginWysiwyg_Paragraph'))
                $obj = & $obj->elements[0];
        } else {
            $obj = & PluginWysiwyg_Factory_Inline($text);
        }

        $this->insert($obj);
    }

    function setStyle(& $style)
    {
        foreach ($style as $key=>$value)
            if (! isset($this->style[$key]))
                $this->style[$key] = $value;
    }

    function toString()
    {
        if ($this->rowspan == 0 || $this->colspan == 0) return '';

        $param = ' class="style_' . $this->tag . '"';
        if ($this->rowspan > 1)
            $param .= ' rowspan="' . $this->rowspan . '"';
        if ($this->colspan > 1) {
            $param .= ' colspan="' . $this->colspan . '"';
            unset($this->style['width']);
        }
        if (! empty($this->style))
            $param .= ' style="' . join(' ', $this->style) . '"';

        return $this->wrap(parent::toString(), $this->tag, $param, FALSE);
    }
}

// | title1 | title2 | title3 |
// | cell1  | cell2  | cell3  |
// | cell4  | cell5  | cell6  |
class PluginWysiwyg_Table extends PluginWysiwyg_Element
{
    var $type;
    var $types;
    var $col; // number of column

    function PluginWysiwyg_Table($out)
    {
        parent::PluginWysiwyg_Element();

        $cells       = explode('|', $out[1]);
        $this->col   = count($cells);
        $this->type  = strtolower($out[2]);
        $this->types = array($this->type);
        $is_template = ($this->type == 'c');
        $row = array();
        foreach ($cells as $cell)
            $row[] = & new PluginWysiwyg_TableCell($cell, $is_template);
        $this->elements[] = $row;
    }

    function canContain(& $obj)
    {
        return is_a($obj, 'PluginWysiwyg_Table') && ($obj->col == $this->col);
    }

    function & insert(& $obj)
    {
        $this->elements[] = $obj->elements[0];
        $this->types[]    = $obj->type;
        return $this;
    }

    function toString()
    {
        static $parts = array('h'=>'thead', 'f'=>'tfoot', ''=>'tbody');

        // rowspanݒ()
        for ($ncol = 0; $ncol < $this->col; $ncol++) {
            $rowspan = 1;
            foreach (array_reverse(array_keys($this->elements)) as $nrow) {
                $row = & $this->elements[$nrow];
                if ($row[$ncol]->rowspan == 0) {
                    ++$rowspan;
                    continue;
                }
                $row[$ncol]->rowspan = $rowspan;
                while (--$rowspan) // sʂp
                    $this->types[$nrow + $rowspan] = $this->types[$nrow];
                $rowspan = 1;
            }
        }

        // colspan,styleݒ
        $stylerow = NULL;
        foreach (array_keys($this->elements) as $nrow) {
            $row = & $this->elements[$nrow];
            if ($this->types[$nrow] == 'c')
                $stylerow = & $row;
            $colspan = 1;
            foreach (array_keys($row) as $ncol) {
                if ($row[$ncol]->colspan == 0) {
                    ++$colspan;
                    continue;
                }
                $row[$ncol]->colspan = $colspan;
                if ($stylerow !== NULL) {
                    $row[$ncol]->setStyle($stylerow[$ncol]->style);
                    while (--$colspan) // X^Cp
                        $row[$ncol - $colspan]->setStyle($stylerow[$ncol]->style);
                }
                $colspan = 1;
            }
        }

        // eLXg
        $string = '';
        foreach ($parts as $type => $part)
        {
            $part_string = '';
            foreach (array_keys($this->elements) as $nrow) {
                if ($this->types[$nrow] != $type)
                    continue;
                $row        = & $this->elements[$nrow];
                $row_string = '';
                foreach (array_keys($row) as $ncol)
                    $row_string .= $row[$ncol]->toString();
                $part_string .= $this->wrap($row_string, 'tr');
            }
            $string .= $this->wrap($part_string, $part);
        }
        $string = $this->wrap($string, 'table', ' class="style_table" cellspacing="1" border="0"');

        return $this->wrap($string, 'div', ' class="ie5"');
    }
}

// , title1 , title2 , title3
// , cell1  , cell2  , cell3
// , cell4  , cell5  , cell6
class PluginWysiwyg_YTable extends PluginWysiwyg_Element
{
    var $col;

    function PluginWysiwyg_YTable($_value)
    {
        parent::PluginWysiwyg_Element();

        $align = $value = $matches = array();
        foreach($_value as $val) {
            if (preg_match('/^(\s+)?(.+?)(\s+)?$/', $val, $matches)) {
                $align[] =($matches[1] != '') ?
                    ((isset($matches[3]) && $matches[3] != '') ?
                        ' style="text-align:center"' :
                        ' style="text-align:right"'
                    ) : '';
                $value[] = $matches[2];
            } else {
                $align[] = '';
                $value[] = $val;
            }
        }
        $this->col = count($value);
        $colspan = array();
        foreach ($value as $val)
            $colspan[] = ($val == '==') ? 0 : 1;
        $str = '';
        $count = count($value);
        for ($i = 0; $i < $count; $i++) {
            if ($colspan[$i]) {
                while ($i + $colspan[$i] < $count && $value[$i + $colspan[$i]] == '==')
                    $colspan[$i]++;
                $colspan[$i] = ($colspan[$i] > 1) ? ' colspan="' . $colspan[$i] . '"' : '';
                $str .= '<td class="style_td"' . $align[$i] . $colspan[$i] . '>' . make_link($value[$i]) . '</td>';
            }
        }
        $this->elements[] = $str;
    }

    function canContain(& $obj)
    {
        return is_a($obj, 'PluginWysiwyg_YTable') && ($obj->col == $this->col);
    }

    function & insert(& $obj)
    {
        $this->elements[] = $obj->elements[0];
        return $this;
    }

    function toString()
    {
        $rows = '';
        foreach ($this->elements as $str)
            $rows .= "\n" . '<tr class="style_tr">' . $str . '</tr>' . "\n";
        $rows = $this->wrap($rows, 'table', ' class="style_table" cellspacing="1" border="0"');
        return $this->wrap($rows, 'div', ' class="ie5"');
    }
}

// ' 'Space-beginning sentence
// ' 'Space-beginning sentence
// ' 'Space-beginning sentence
class PluginWysiwyg_Pre extends PluginWysiwyg_Element
{
    function PluginWysiwyg_Pre(& $root, $text)
    {
        global $preformat_ltrim;
        parent::PluginWysiwyg_Element();
        $this->elements[] = htmlspecialchars(
            (! $preformat_ltrim || $text == '' || $text{0} != ' ') ? $text : substr($text, 1));
    }

    function canContain(& $obj)
    {
        return is_a($obj, 'PluginWysiwyg_Pre');
    }

    function & insert(& $obj)
    {
        $this->elements[] = $obj->elements[0];
        return $this;
    }

    function toString()
    {
        return $this->wrap(join("\n", $this->elements), 'pre');
    }
}

// #something (started with '#')
class PluginWysiwyg_Div extends PluginWysiwyg_Element
{
    var $name;
    var $param;

    function PluginWysiwyg_Div($out)
    {
        parent::PluginWysiwyg_Element();
        list(, $this->name, $this->param) = array_pad($out, 3, '');
    }

    function canContain(& $obj)
    {
        return FALSE;
    }

    function toString()
    {
        return do_plugin_convert($this->name, $this->param);
    }
}

// LEFT:/CENTER:/RIGHT:
class PluginWysiwyg_Align extends PluginWysiwyg_Element
{
    var $align;

    function PluginWysiwyg_Align($align)
    {
        parent::PluginWysiwyg_Element();
        $this->align = $align;
    }

    function canContain(& $obj)
    {
        return is_a($obj, 'PluginWysiwyg_Inline');
    }

    function toString()
    {
        return $this->wrap(parent::toString(), 'div', ' style="text-align:' . $this->align . '"');
    }
}

// PluginWysiwyg_Body
class PluginWysiwyg_Body extends PluginWysiwyg_Element
{
    var $id;
    var $count = 0;
    var $contents;
    var $contents_last;
    var $classes = array(
        '-' => 'UList',
        '+' => 'OList',
        '>' => 'BQuote',
        '<' => 'BQuote',
        );
    var $factories = array(
        ':' => 'DList',
        '|' => 'Table',
        ',' => 'YTable',
        '#' => 'Div');

    function PluginWysiwyg_Body($id)
    {
        $this->id            = $id;
        $this->contents      = & new PluginWysiwyg_Element();
        $this->contents_last = & $this->contents;
        parent::PluginWysiwyg_Element();
    }

    function parse(& $lines)
    {
        $this->last = & $this;
        $matches = array();

        while (! empty($lines)) {
            $line = array_shift($lines);

            // Escape comments
            if (substr($line, 0, 2) == '//') continue;
            
            /* wysiwyg: ΉB
            if (preg_match('/^(LEFT|CENTER|RIGHT):(.*)$/', $line, $matches)) {
                // <div style="text-align:...">
                $this->last = & $this->last->add(new PluginWysiwyg_Align(strtolower($matches[1])));
                if ($matches[2] == '') continue;
                $line = $matches[2];
            }
            */

            $line = preg_replace("/[\r\n]*$/", '', $line);

            // Empty
            if ($line == '') {
                $this->last = & $this;
                continue;
            }

            // Horizontal Rule
            if (substr($line, 0, 4) == '----') {
                $this->insert(new PluginWysiwyg_HRule($this, $line));
                continue;
            }

            // The first character
            $head = $line{0};

            // PluginWysiwyg_Heading
            if ($head == '*') {
                $this->insert(new PluginWysiwyg_Heading($this, $line));
                continue;
            }

            // PluginWysiwyg_Pre
            if ($head == ' ' || $head == "\t") {
                $this->last = & $this->last->add(new PluginWysiwyg_Pre($this, $line));
                continue;
            }

            // Line Break
            if (substr($line, -1) == '~')
                $line = substr($line, 0, -1) . "\r";
            
            // Other Character
            if (isset($this->classes[$head])) {
                $classname  = 'PluginWysiwyg_'.$this->classes[$head];
                $this->last = & $this->last->add(new $classname($this, $line));
                continue;
            }

            // Other Character
            if (isset($this->factories[$head])) {
                $factoryname = 'PluginWysiwyg_Factory_' . $this->factories[$head];
                $this->last  = & $this->last->add($factoryname($this, $line));
                continue;
            }

            // Default
            $this->last = & $this->last->add(PluginWysiwyg_Factory_Inline($line));
        }
    }

    function getAnchor($text, $level)
    {
        global $top, $_symbol_anchor;

        $id = make_heading($text, FALSE); // Cut fixed-anchor from $text
        $anchor = ($id == '') ?  '' : ' &aname(' . $id . ',super,full){' . $_symbol_anchor . '};';

        $text = ' ' . $text;
        $id = 'content_' . $this->id . '_' . $this->count;
        $this->count++;
        $this->contents_last = & $this->contents_last->add(new PluginWysiwyg_Contents_UList($text, $level, $id));

        return array($text . $anchor, $this->count > 1 ? "\n" . $top : '', $id);
    }

    function & insert(& $obj)
    {
        if (is_a($obj, 'PluginWysiwyg_Inline')) $obj = & $obj->toPara();
        return parent::insert($obj);
    }

    function toString()
    {
        global $vars;

        $text = parent::toString();

        // #contents
        $text = preg_replace_callback('/(<p[^>]*>)<del>#contents<\/del>(\s*)(<\/p>)/',
            array(& $this, 'replace_contents'), $text);

        // ֘Ay[W
        // <p>̂Ƃ͍sA<del>̂Ƃ̗͑vf̎qvfƂđ
        $text = preg_replace_callback('/(<p[^>]*>)<del>#related<\/del>(\s*)(<\/p>)/',
            array(& $this, 'replace_related'), $text);
        $text = preg_replace('/<del>#related<\/del>/', make_related($vars['page'], 'del'), $text);
        return $text . "\n";
    }

    function replace_contents($arr)
    {
        $contents  = '<div class="contents">' . "\n" .
                '<a id="contents_' . $this->id . '"></a>' . "\n" .
                $this->contents->toString() . "\n" .
                '</div>' . "\n";
        array_shift($arr);
        return ($arr[1] != '') ? $contents . join('', $arr) : $contents;
    }

    function replace_related($arr)
    {
        global $vars;
        static $related = NULL;

        if (is_null($related)) $related = make_related($vars['page'], 'p');
        array_shift($arr);
        return ($arr[1] != '') ? $related . join('', $arr) : $related;
    }
}

class PluginWysiwyg_Contents_UList extends PluginWysiwyg_ListContainer
{
    function PluginWysiwyg_Contents_UList($text, $level, $id)
    {
        // eLXg̃tH[
        // s\nŐ`ς݂\ ... X(
        make_heading($text);
        $text = "\n" . '<a href="#' . $id . '">' . $text . '</a>' . "\n";
        parent::PluginWysiwyg_ListContainer('ul', 'li', '-', str_repeat('-', $level));
        $this->insert(PluginWysiwyg_Factory_Inline($text));
    }

    function setParent(& $parent)
    {
        global $_list_pad_str;

        parent::setParent($parent);
        $step   = $this->level;
        $margin = $this->left_margin;
        if (isset($parent->parent) && is_a($parent->parent, 'PluginWysiwyg_ListContainer')) {
            $step  -= $parent->parent->level;
            $margin = 0;
        }
        $margin += $this->margin * ($step == $this->level ? 1 : $step);
        $this->style = sprintf($_list_pad_str, $this->level, $margin, $margin);
    }
}
?>
