<?php
// PukiWiki - Yet another WikiWikiWeb clone.
// $Id: make_link.php,v 1.17 2005/02/05 03:40:13 henoheno Exp $
//
// Hyperlink-related functions

// Hyperlink decoration
function plugin_wysiwyg_make_link($string, $page = '')
{
    global $vars;
    static $converter;

    if (! isset($converter)) $converter = new PluginWysiwyg_InlineConverter();

    $clone = $converter->get_clone($converter);
    
    //print($string."=>");
    $string = $clone->convert($string, ($page != '') ? $page : $vars['page']);
    //print($string."<br>");
    return $string;
}

// Converters of inline element
class PluginWysiwyg_InlineConverter extends InlineConverter
{
    
    function PluginWysiwyg_InlineConverter(){
        
        //ʂȃRo[^g
        parent::InlineConverter(array("plugin_wysiwyg_url"));
        
        $ie = ereg("MSIE", UA_NAME);
        
        //line_rules
        $this->line_rules = array(
            "\r"          => '<br />' . "\n",   /* sɃ`_͉s */
            /*
            'COLOR\(([^\(\)]*)\){([^}]*)}'  => '<span style="color:$1">$2</span>',
            'SIZE\(([^\(\)]*)\){([^}]*)}'   => '<span style="font-size:$1px">$2</span>',
            'COLOR\(([^\(\)]*)\):((?:(?!COLOR\([^\)]+\)\:).)*)' => '<span style="color:$1">$2</span>',
            'SIZE\(([^\(\)]*)\):((?:(?!SIZE\([^\)]+\)\:).)*)'   => '<span class="size$1">$2</span>',
            */
            
            //ꂼ̃uEUWYSIWYGҏWŎĝɍ킹ȂƁA܂ҏWłȂ
            '%%(?!%)((?:(?!%%).)*)%%' =>
                $ie ? '<strike>$1</strike>' : '<span style="text-decoration: line-through;">$1</span>',
            "'''(?!')((?:(?!'').)*)'''" =>
                $ie ? '<em>$1</em>' : '<span style="font-style: italic;">$1</span>',
            "''(?!')((?:(?!''').)*)''" =>
                $ie ? '<strong>$1</strong>' : '<span style="font-weight: bold;">$1</span>',
            
            '&amp;br;'  => '<br />',
        );
        
    }
    
    function convert($string, $page)
    {
        $this->page   = $page;
        $this->result = array();
        $string = preg_replace_callback('/' . $this->pattern . '/x',
            array(& $this, 'replace'), $string);
        
        //Ǝmake_line_rulesg
        $arr = explode("\x08", $this->make_line_rules(htmlspecialchars($string)));
        $retval = '';
        while (! empty($arr)) {
            $retval .= array_shift($arr) . array_shift($this->result);
        }
        return $retval;
    }

    function replace($arr)
    {
        $obj = $this->get_converter($arr);

        //Ǝmake_line_rulesg
        $this->result[] = ($obj !== NULL && $obj->set($arr, $this->page) !== FALSE) ?
            $obj->toString() : $this->make_line_rules(htmlspecialchars($arr[0]));

        return "\x08"; // Add a mark into latest processed part
    }
    
    function make_line_rules($str){
        static $pattern, $replace;
        if (! isset($pattern)) {
            $pattern = array_map(create_function('$a',
                'return \'/\' . $a . \'/\';'), array_keys($this->line_rules));
            $replace = array_values($this->line_rules);
        }
        return preg_replace($pattern, $replace, $str);
    }
    
}

class Link_plugin_wysiwyg_url extends Link_url
{
    
    function get_pattern()
    {
        $s1 = $this->start + 1;
        //URL݂̂͑ΏۊO
        return <<<EOD
(\[\[             # (1) open bracket
 ((?:(?!\]\]).)+) # (2) alias
 (?:>|:)
)
(                 # (3) url
 (?:(?:https?|ftp|news):\/\/|mailto:)[\w\/\@\$()!?&%#:;.,~'=*+-]+
)
(?($s1)\]\])      # close bracket
EOD;
    }
    
}
